/*
 * Created by SharpDevelop.
 * User: Stephen
 * Date: 3/23/2009
 * Time: 2:44 PM
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;
using System.Text;

namespace UsingGenerics
{
	class MainClass
	{
		public static void Main(string[] args)
		{
			Contractor contractor = new Contractor("A Contractor");
			Employee employee = new Employee("An Employee");
			Employee employee1 = new Employee("Another Employee");
			
			GenericCollection<Person> genericCollection = new GenericCollection<Person>();
			Console.WriteLine("Collection capacity: " + genericCollection.MyGenericCollection.Capacity);
			
			genericCollection.MyGenericCollection.Add(employee);
			genericCollection.MyGenericCollection.Add(contractor);
			genericCollection.MyGenericCollection.Add(employee1);
			
			foreach (Person p in genericCollection)
			{
				Console.WriteLine("Person called: " + p.Name);
			}
			
			Console.WriteLine("Number of entries: " + genericCollection.MyGenericCollection.Count);
//			genericCollection.MyGenericCollection.Remove(employee1);
//			Console.WriteLine("Number of entries: " + genericCollection.MyGenericCollection.Count);
			
			for (int i = 0; i < genericCollection.MyGenericCollection.Count; i++) {
				Console.WriteLine("Name is " + genericCollection.MyGenericCollection[i].Name);
			}
			
			Console.WriteLine();
			genericCollection.MyGenericCollection.Sort();

			for (int i = 0; i < genericCollection.MyGenericCollection.Count; i++) {
				Console.WriteLine("Sorted name is " + genericCollection.MyGenericCollection[i].Name);
			}
			
			genericCollection.MyGenericCollection.Find(AnotherEmployee);
			
			Console.WriteLine("Default values {0} {1} ", default(bool), default(int));
			
			Console.ReadLine();
		}
		
		private static bool AnotherEmployee(Person p) 
		{
			if (p.Name.Equals("Another Employee"))
        {
				Console.WriteLine("Managed to locate: " + "Another Employee");
				return true;
        }
        else
        {
            return false;
        }
    }
	}
}
